
#include "osd_cpu.h"
#include <string.h>
#include "stdlib.h"
#include "defs.h"
typedef unsigned int u32;

int rand(); //libdemocd.a

#include <kallisti/abi/fundamental.h>
extern abi_fundamental_t *fabi;

void *realloc(void *oldmem, size_t bytes) {
        return fabi->realloc(oldmem,bytes);
}

void *sys_timer() {
        return time(100);
}
int sys_elapsed(int cl) {
        int i;
        i=time(100);
        cl=i;
        return 1000000+i;
}
void sys_sleep(int us) {
        thd->sleep(us);
}

char * strdup(char const * str) {
        size_t len = strlen (str) + 1;
        char *copy = malloc (len);
        if (copy) {
                memcpy(copy, str, len);
        }
        return copy;
}

void sys_initpath(char *exe) {
	char *buf, *home, *p;

	home = strdup(exe);
	p = strrchr(home, '/');
        if (p) {
                *p = 0;
        } else {
		rc_setvar("rcpath", ".");
		rc_setvar("savedir", ".");
		return;
	}
	buf = malloc(strlen(home) + 8);
	sprintf(buf, ".;%s/", home);
	rc_setvar("rcpath", 1, &buf);
	sprintf(buf, ".");
	rc_setvar("savedir", 1, &buf);
	free(buf);
}

void sys_sanitize(char *s) {
	int i;
	for (i = 0; s[i]; i++)
		if (s[i] == '\\') s[i] = '/';
}

void sys_checkdir(char *path, int wr) {
}

void fscanf(void *arg, ...) {
        return;
}

int srand(int arg) {
	int shift, i;
	
        for (i=0, shift=1; arg < shift; shift<<=1, i++)
		;
		
        return ((rand() >> shift) & 0x7fffffff) % arg;
}

void fflush(void *num) {
        return;
}

int signal(int f, void *fa) {
        return 0;
}

int abs(int i) {
        return (i < 0) ? -i : i;
}

int atoi(const char *s) {
	int a = 0;
        if (*s == '0') {
		s++;
                if (*s == 'x' || *s == 'X') {
			s++;
                        while (*s) {
				if (isdigit(*s))
					a = (a<<4) + *s - '0';
				else if (strchr("ABCDEF", *s))
					a = (a<<4) + *s - 'A' + 10;
				else if (strchr("abcdef", *s))
					a = (a<<4) + *s - 'a' + 10;
				else return a;
				s++;
			}
			return a;
		}
                while (*s) {
			if (strchr("01234567", *s))
				a = (a<<3) + *s - '0';
			else return a;
			s++;
		}
		return a;
	}
        if (*s == '-') {
		s++;
                for (;;) {
			if (isdigit(*s))
				a = (a*10) + *s - '0';
			else return -a;
			s++;
		}
	}
        while (*s) {
		if (isdigit(*s))
			a = (a*10) + *s - '0';
		else return a;
		s++;
	}
	return a;
}

time_t time(time_t *_timer) {
	int vals[2];

	vals[0] = *((volatile u32 *) (0xA0710000));
	vals[1] = *((volatile u32 *) (0xA0710004));

	return (((vals[0] & 0x0000FFFF) << 16) | (vals[1] & 0x0000FFFF));
}
#define EOF	(-1)

FILE * fopen(const char *path, const char *mode) {
        printf("fopen(%s,%s);\r\n",path,mode);

        if (mode[0] == 'r')
                return (FILE *)fs->open(path, O_RDONLY);
        if (mode[0] == 'w')
                return (FILE *)fs->open(path, O_WRONLY);
        return 0;
}

int fclose(FILE *stream)
{
        fs->close((unsigned int)stream);
        return 0;
}

unsigned int fread(void *ptr, unsigned int size, unsigned int nmemb, FILE *stream) {
        return fs->read((unsigned int)stream, ptr, size*nmemb)/size;
}

unsigned int fwrite(void *ptr, unsigned int size, unsigned int nmemb, FILE *stream) {
        return fs->write((unsigned int)stream, ptr, size*nmemb)/size;
}

int fseek(FILE *stream, long offset, int whence) {
        return fs->seek((unsigned int)stream, offset, whence);
}

int fgetc(FILE *stream) {
        char c[1];
        fs->read((unsigned int)stream,c,1);
        return c[0];
}


/*char *fgets(char *s, int size, FILE *stream) {
	char *orig=s;
	int l;
	for (l=size; l>0;) {
                int c=fgetc(stream);
		if (c==EOF) break;
		*s=c;
		++s;
		--l;
		if (c=='\n') break;
	}
        if (l==size || ferror(stream))
		return 0;
	s=0;
	return orig;
}*/

void exit(int f) {
        printf("Exit code %d called... shutting down KallistiOS-1.0.0\r\n", f);
        lib_close(maple);
        lib_close(ta);
        lib_close(video);
        lib_close(fs);
        lib_close(thd);
        lib_close(process);
        for(;;);        
}
